package me.zhengjie.modules.bizs.biz.sec;

package ..deTemp.1734159023471;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import java.lang.invoke.SerializedLambda;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import me.zhengjie.base.DeptVo;
import me.zhengjie.base.RoleSmallDto;
import me.zhengjie.modules.bizs.biz.base.ActivityApprovalOneBiz;
import me.zhengjie.modules.bizs.biz.base.ActivityApprovalThreeBiz;
import me.zhengjie.modules.bizs.biz.base.ActivityApprovalTwoBiz;
import me.zhengjie.modules.bizs.biz.base.BaseDataLogBiz;
import me.zhengjie.modules.bizs.biz.base.BaseFunctionBiz;
import me.zhengjie.modules.bizs.biz.base.DataApproveBiz;
import me.zhengjie.modules.bizs.biz.base.DepartBiz;
import me.zhengjie.modules.bizs.biz.base.DeptBiz;
import me.zhengjie.modules.bizs.biz.base.TblAttachmentsBiz;
import me.zhengjie.modules.bizs.biz.sec.TblCheckSecurityRectifyLogBiz;
import me.zhengjie.modules.bizs.domain.base.BaseCheckRecord;
import me.zhengjie.modules.bizs.domain.base.BasePoint;
import me.zhengjie.modules.bizs.domain.base.BasePointCheckConfig;
import me.zhengjie.modules.bizs.domain.base.DataApprove;
import me.zhengjie.modules.bizs.domain.base.DepartSub;
import me.zhengjie.modules.bizs.domain.base.SysStationRelation;
import me.zhengjie.modules.bizs.domain.curingTable.TblCheckSecurityCuring;
import me.zhengjie.modules.bizs.domain.enums.DataApplyTypeEnum;
import me.zhengjie.modules.bizs.domain.enums.MenuTypeEnum;
import me.zhengjie.modules.bizs.domain.enums.ModulePublicType;
import me.zhengjie.modules.bizs.domain.enums.ModuleType;
import me.zhengjie.modules.bizs.domain.enums.ProcessRankEnum;
import me.zhengjie.modules.bizs.domain.enums.RectifyEnum;
import me.zhengjie.modules.bizs.domain.enums.RoleLevelEnum;
import me.zhengjie.modules.bizs.domain.enums.UserLevelEnum;
import me.zhengjie.modules.bizs.domain.sec.TblAttachments;
import me.zhengjie.modules.bizs.domain.sec.TblCheckSecurity;
import me.zhengjie.modules.bizs.domain.sec.TblCheckSecurityAjy;
import me.zhengjie.modules.bizs.domain.sec.TblCheckSecurityRectify;
import me.zhengjie.modules.bizs.mapper.base.BaseCheckRecordMapper;
import me.zhengjie.modules.bizs.mapper.base.BasePointCheckConfigMapper;
import me.zhengjie.modules.bizs.mapper.base.BasePointMapper;
import me.zhengjie.modules.bizs.mapper.base.DataApproveMapper;
import me.zhengjie.modules.bizs.mapper.base.DepartSubMapper;
import me.zhengjie.modules.bizs.mapper.base.DeptMapper;
import me.zhengjie.modules.bizs.mapper.base.SysStationRelationMapper;
import me.zhengjie.modules.bizs.mapper.curingTable.TblCheckSecurityCuringMapper;
import me.zhengjie.modules.bizs.mapper.sec.TblCheckSecurityAjyMapper;
import me.zhengjie.modules.bizs.mapper.sec.TblCheckSecurityMapper;
import me.zhengjie.modules.bizs.mapper.sec.TblCheckSecurityRectifyMapper;
import me.zhengjie.modules.bizs.msg.ObjectRestResponse;
import me.zhengjie.modules.bizs.msg.TableResultResponse;
import me.zhengjie.modules.bizs.utils.DateUtil;
import me.zhengjie.modules.system.domain.Dept;
import me.zhengjie.modules.system.service.DictDetailService;
import me.zhengjie.utils.SecurityUtils;
import me.zhengjie.utils.StringUtils;
import org.activiti.engine.task.Task;
import org.apache.commons.lang3.time.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

@Service
public class TblCheckSecurityBiz {
  @Autowired
  TblCheckSecurityMapper securityMapper;
  
  @Autowired
  TblCheckSecurityAjyMapper securityAjyMapper;
  
  @Autowired
  TblAttachmentsBiz attachmentsBiz;
  
  @Autowired
  BaseCheckRecordMapper recordMapper;
  
  @Autowired
  DeptMapper deptMapper;
  
  @Autowired
  DepartBiz departBiz;
  
  @Autowired
  TblCheckSecurityRectifyMapper rectifyMapper;
  
  @Autowired
  BaseFunctionBiz baseFunctionBiz;
  
  @Autowired
  SysStationRelationMapper relationMapper;
  
  @Autowired
  TblCheckSecurityCuringMapper securityCuringMapper;
  
  @Autowired
  BasePointMapper pointMapper;
  
  @Autowired
  BasePointCheckConfigMapper pointCheckConfigMapper;
  
  @Autowired
  TblCheckSecurityRectifyLogBiz logBiz;
  
  @Autowired
  ActivityApprovalThreeBiz threeBiz;
  
  @Autowired
  ActivityApprovalTwoBiz twoBiz;
  
  @Autowired
  ActivityApprovalOneBiz oneBiz;
  
  @Autowired
  DeptBiz deptBiz;
  
  @Autowired
  BaseDataLogBiz dataLogBiz;
  
  @Autowired
  DepartSubMapper departSubMapper;
  
  @Autowired
  DataApproveBiz dataApproveBiz;
  
  @Autowired
  DataApproveMapper dataApproveMapper;
  
  @Autowired
  DictDetailService dictDetailService;
  
  public TblCheckSecurity selectById(Integer id) {
    TblCheckSecurity security = (TblCheckSecurity)this.securityMapper.selectById(id);
    return security;
  }
  
  public TableResultResponse query(String startTime, String endTime, Integer level, String status, Integer rectifyType, String lineId, String[] stationId, Integer page, Integer limit, String stationName, Integer checkItem, Integer isProblem, Integer operId, String subLineId) {
    int isAdmin = SecurityUtils.getCurrentUserIsAdmin();
    List<String> departIds = null;
    if (StringUtils.isNotEmpty(lineId))
      departIds = this.baseFunctionBiz.get_child_base_depart_list_array(lineId); 
    String[] arr = null;
    if (StringUtils.isNotEmpty(status))
      arr = status.split(","); 
    List<String> stationScope = new ArrayList<>();
    if (isAdmin != 1)
      stationScope = SecurityUtils.getCurrentUserStationScope(); 
    Page<Object> result = PageHelper.startPage(page.intValue(), limit.intValue());
    List<TblCheckSecurity> securities = this.securityMapper.selectCheckSecurityList(startTime, endTime, level, arr, rectifyType, departIds, stationId, stationScope, null, stationName, checkItem, isProblem, operId, subLineId);
    if (1 == this.dictDetailService.getDictByNameAndStr("data_approve", "check_security").intValue())
      for (TblCheckSecurity data : securities)
        data.setApproveInfo(this.dataApproveBiz.getApproveInfo(Long.valueOf(Long.parseLong(data.getId() + "")), DataApplyTypeEnum.安检检查.getValue(), Integer.valueOf(0), null));  
    return new TableResultResponse(result.getTotal(), securities);
  }
  
  public ObjectRestResponse checkAjyBasic(TblCheckSecurity security) {
    if (CollUtil.isEmpty(security.getIdCards()))
      return ObjectRestResponse.error("请先选择人员! "); 
    if (StringUtils.isEmpty(security.getPointId()))
      return ObjectRestResponse.error("请先选择安检点! "); 
    if (StringUtils.isEmpty(security.getDateTime()))
      security.setDateTime(DateUtil.dateToString(new Date(), "yyyy-MM-dd HH:mm:ss")); 
    int level = Integer.MAX_VALUE;
    List<RoleSmallDto> roles = SecurityUtils.getCurrentUserRoles();
    for (RoleSmallDto r : roles) {
      if (r.getLevel().intValue() < level)
        level = r.getLevel().intValue(); 
    } 
    String date = DateUtil.dateStrToStringFormat(security.getDateTime(), "yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd");
    List<TblCheckSecurityAjy> res = this.securityAjyMapper.selectByIdCards(security.getIdCards(), security.getPointId(), security.getDateTime(), date, Integer.valueOf(level), SecurityUtils.getCurrentUserId());
    if (level != RoleLevelEnum.班组.getValue().intValue())
      return ObjectRestResponse.ok(res.stream().distinct().collect(Collectors.toList())); 
    BasePoint basePoint = (BasePoint)this.pointMapper.selectById(security.getPointId());
    String highSdate = "";
    String highEdate = "";
    String timeType = this.pointMapper.getTimeType(security.getDateTime(), basePoint.getId());
    if (StringUtils.isEmpty(timeType))
      return ObjectRestResponse.ok(res); 
    if ("1".equals(timeType)) {
      highSdate = date + " " + basePoint.getHighStime1() + ":00";
      highEdate = date + " " + basePoint.getHighEtime1() + ":00";
    } else if ("2".equals(timeType)) {
      highSdate = date + " " + basePoint.getHighStime2() + ":00";
      highEdate = date + " " + basePoint.getHighEtime2() + ":00";
    } 
    List<TblCheckSecurityAjy> res1 = this.securityAjyMapper.selectByHighTime(highSdate, highEdate, RoleLevelEnum.班组.getValue());
    res.addAll(res1);
    return ObjectRestResponse.ok(res.stream().distinct().collect(Collectors.toList()));
  }
  
  public ObjectRestResponse checkAdd(TblCheckSecurity rectify) {
    if (StringUtils.isEmpty(rectify.getPointId()))
      return ObjectRestResponse.error("安检点不能为空"); 
    if (null == rectify.getCheckTime())
      return ObjectRestResponse.error("检查时间不能为空"); 
    LambdaQueryWrapper<TblCheckSecurity> queryWrapper = new LambdaQueryWrapper();
    queryWrapper.eq(TblCheckSecurity::getPointId, rectify.getPointId());
    queryWrapper.eq(TblCheckSecurity::getCreateId, SecurityUtils.getCurrentUserId().toString());
    queryWrapper.apply("TIMESTAMPDIFF(MINUTE,CHECK_TIME,{0}) <= 5", new Object[] { rectify.getCheckTime() });
    return ObjectRestResponse.ok(this.securityMapper.selectCount((Wrapper)queryWrapper));
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ObjectRestResponse add(TblCheckSecurity re) {
    if (CheckUserAdd())
      return ObjectRestResponse.error("检查频率过高，请认真检查! "); 
    try {
      int level = Integer.MAX_VALUE;
      List<RoleSmallDto> roles = SecurityUtils.getCurrentUserRoles();
      for (RoleSmallDto r : roles) {
        if (r.getLevel().intValue() < level)
          level = r.getLevel().intValue(); 
      } 
      Integer timeR = Integer.valueOf(0);
      if (level == RoleLevelEnum.集团.getValue().intValue())
        timeR = this.dictDetailService.getDictByNameAndStr("timeRange", "checkSecurity_level_1"); 
      if (level == RoleLevelEnum.运营公司.getValue().intValue())
        timeR = this.dictDetailService.getDictByNameAndStr("timeRange", "checkSecurity_level_2"); 
      if (level == RoleLevelEnum.站区.getValue().intValue())
        timeR = this.dictDetailService.getDictByNameAndStr("timeRange", "checkSecurity_level_3"); 
      if (level == RoleLevelEnum.班组.getValue().intValue())
        timeR = this.dictDetailService.getDictByNameAndStr("timeRange", "checkSecurity_level_4"); 
      if (timeR == null || timeR.intValue() == 0) {
        timeR = Integer.valueOf(1);
      } else {
        Integer integer1 = timeR, integer2 = timeR = Integer.valueOf(timeR.intValue() + 1);
      } 
      if (timeR != null) {
        Date now = new Date();
        Date t = DateUtil.getBeforeHour(now, -timeR.intValue());
        if (t.after(re.getCheckTime()))
          return ObjectRestResponse.error("检查时间不能低于" + DateUtil.date2Str(t, "yyyy-MM-dd HH:mm:ss")); 
        now.setTime(now.getTime() + 120000L);
        if (now.before(re.getCheckTime()))
          return ObjectRestResponse.error("检查时间不能超过当前时间"); 
      } 
      DeptVo dept = SecurityUtils.getCurrentUserDept();
      Dept de = this.deptBiz.selectDeptByCode(dept.getId());
      if (null != de) {
        re.setOperCode(de.getCode());
        re.setOperId(de.getId().toString());
        re.setOperName(de.getName());
      } 
      if (StringUtils.isNotEmpty(re.getStationId())) {
        DepartSub sub = this.departSubMapper.selectSubByStation(re.getStationId());
        re.setLineId(sub.getId());
        re.setLineName(sub.getName());
      } 
      if (StringUtils.isNotEmpty(re.getPointId())) {
        Integer timeType = this.rectifyMapper.selectTimeType(re.getPointId(), DateUtil.dateToString(re.getCheckTime(), "yyyy-MM-dd HH:mm:ss"));
        re.setTimeType(timeType);
      } 
      re.setCheckDeaprtCode(dept.getCode());
      re.setCheckDepartId(dept.getId().toString());
      re.setCheckDepart(dept.getName());
      re.setLevel(dept.getLevel());
      re.setCreateId(SecurityUtils.getCurrentUserId().toString());
      re.setCreateName(SecurityUtils.getCurrentUsername());
      re.setCreateTime(new Date());
      if (re.getRectifyType().intValue() == 1) {
        Date date = null;
        if (re.getRectifyPeriod().intValue() == 1) {
          date = DateUtils.addDays(new Date(), 3);
        } else if (re.getRectifyPeriod().intValue() == 2) {
          date = DateUtils.addDays(new Date(), 7);
        } else if (re.getRectifyPeriod().intValue() == 3) {
          date = DateUtils.addDays(new Date(), 30);
        } 
        re.setRectifyTime(date);
        re.setStatus(Integer.valueOf(0));
      } else {
        re.setOnSitePic(re.getOnSitePic());
        re.setStatus(Integer.valueOf(1));
      } 
      this.securityMapper.insert(re);
      if (CollUtil.isNotEmpty(re.getCheckAjyList())) {
        List<TblCheckSecurityAjy> checkAjyList = re.getCheckAjyList();
        Integer finalLevel = Integer.valueOf(level);
        checkAjyList.forEach(x -> {
              x.setPointId(re.getPointId());
              x.setPointName(re.getPointName());
              x.setCheckId(re.getId());
              x.setCreateTime(new Date());
              x.setUserLevel(finalLevel);
              x.setUserId(SecurityUtils.getCurrentUserId());
            });
        this.securityAjyMapper.insertBatchSomeColumn(re.getCheckAjyList());
      } 
      this.dataLogBiz.insertLog(SecurityUtils.getCurrentUserDept().getId(), null, null, Integer.valueOf(MenuTypeEnum.安检检查.getValue()), Integer.valueOf(ModulePublicType.监督检查.getValue()), ModulePublicType.监督检查.name(), "", "新增安检检查", Integer.valueOf(0), Integer.valueOf(ModuleType.公共安全防范.getValue()), re.getId().toString());
      if (re.getRectifyType().intValue() == 1) {
        TblCheckSecurityRectify rectify = new TblCheckSecurityRectify();
        rectify.setStartTime(new Date());
        rectify.setEndTime(re.getRectifyTime());
        rectify.setCheckId(re.getId());
        addTblCheckSecurityRectify(rectify);
      } else if (re.getRectifyType().intValue() == 0) {
        TblCheckSecurityRectify rectify = new TblCheckSecurityRectify();
        rectify.setCheckId(re.getId());
        addCheckLog(rectify);
      } 
      if (null != re.getPicList() && re.getPicList().size() > 0)
        this.attachmentsBiz.insertAttachments(re.getPicList(), re.getId(), Integer.valueOf(0), "tbl_check_security"); 
      if (null != re.getCheckItemFileList() && re.getCheckItemFileList().size() > 0)
        for (TblAttachments att : re.getCheckItemFileList())
          this.attachmentsBiz.insertAttachment(att, re.getId(), att.getMid(), "base_check_record");  
      if (null != re.getRecordList() && re.getRecordList().size() > 0) {
        List<BaseCheckRecord> baseCheckRecords = new ArrayList<>();
        boolean flag = false;
        for (BaseCheckRecord record : re.getRecordList()) {
          if (record.getMid().intValue() == 1 && record.getSid().intValue() == 2)
            for (BaseCheckRecord r : re.getRecordList()) {
              if (r.getMid().intValue() == 1 && r.getSid().intValue() == 1 && 
                Integer.valueOf(r.getData()).intValue() > Integer.valueOf(record.getData()).intValue()) {
                record.setIsProblem(Integer.valueOf(1));
                flag = true;
                break;
              } 
            }  
          if (record.getMid().intValue() == 1 && record.getSid().intValue() == 3)
            for (BaseCheckRecord r : re.getRecordList()) {
              if (r.getMid().intValue() == 1 && r.getSid().intValue() == 2 && 
                Integer.valueOf(r.getData()).intValue() > Integer.valueOf(record.getData()).intValue()) {
                record.setIsProblem(Integer.valueOf(1));
                flag = true;
                break;
              } 
            }  
          record.setCid(re.getId());
          record.setType(Integer.valueOf(1));
          record.setCreateTime(new Date());
          this.recordMapper.insert(record);
          baseCheckRecords.add(record);
        } 
        if (flag && 
          null != baseCheckRecords && baseCheckRecords.size() > 0)
          for (BaseCheckRecord r : baseCheckRecords) {
            if (r.getMid().intValue() == 1) {
              r.setIsProblem(Integer.valueOf(1));
              this.recordMapper.updateById(r);
            } 
          }  
      } 
      BasePointCheckConfig config = this.pointCheckConfigMapper.queryConfigByPoint(re.getPointId(), DateUtil.dateToString(re.getCheckTime(), "HH:mm"));
      List<SysStationRelation> relations = this.relationMapper.getHistoryStation(DateUtil.dateToString(re.getCheckTime(), "yyyy-MM-dd HH:mm:ss"), re.getStationId());
      if (CollUtil.isEmpty(relations))
        return ObjectRestResponse.error("新增失败，标段配置有误!"); 
      SysStationRelation relation = relations.get(0);
      if (null == config)
        return ObjectRestResponse.error("新增失败，安检点配置有误!"); 
      TblCheckSecurityCuring curing = curingTable(re, relation, null, Arrays.asList(new BasePointCheckConfig[] { config }));
      if (null != curing)
        if (null == curing.getId()) {
          this.securityCuringMapper.insert(curing);
        } else {
          this.securityCuringMapper.updateById(curing);
        }  
      return ObjectRestResponse.ok("新增成功");
    } catch (Exception e) {
      TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
      e.printStackTrace();
      return ObjectRestResponse.error("新增失败");
    } 
  }
  
  private boolean CheckUserAdd() {
    Long userId = SecurityUtils.getCurrentUserId();
    TblCheckSecurity security = (TblCheckSecurity)this.securityMapper.selectOne((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper())
        .eq(TblCheckSecurity::getCreateId, userId))
        .orderByDesc(TblCheckSecurity::getCreateTime))
        .last("limit 1"));
    if (security == null)
      return false; 
    long nowTime = (new Date()).getTime();
    long createTime = security.getCreateTime().getTime();
    Integer checkTimeConfig = this.dictDetailService.getDictByNameAndStr("checkConfig", "提交检查间隔(秒)");
    return ((nowTime - createTime) / 1000L <= checkTimeConfig.intValue());
  }
  
  public static void main(String[] args) {
    String date1 = "2024-01-10 00:00:00";
    String date2 = "2024-01-10 01:00:00";
    Date date11 = DateUtil.stringToDate(date1, "yyyy-MM-dd HH:mm:ss");
    Date date22 = DateUtil.stringToDate(date2, "yyyy-MM-dd HH:mm:ss");
    System.out.println((date11.getTime() >= date22.getTime()));
  }
  
  public TblCheckSecurityCuring curingTable(TblCheckSecurity re, SysStationRelation relation, List<TblCheckSecurityCuring> defaultCuring, List<BasePointCheckConfig> configs) {
    String checkDate = DateUtil.dateToString(re.getCheckTime(), "yyyy-MM-dd");
    String checkTime = DateUtil.dateToString(re.getCheckTime(), "HH:mm");
    TblCheckSecurityCuring curing = null;
    if (null == defaultCuring) {
      curing = this.securityCuringMapper.getDefaultData(re.getPointId(), checkTime, checkDate + " 00:00:00", checkDate + " 23:59:59");
    } else {
      for (TblCheckSecurityCuring c : defaultCuring) {
        if (!StringUtils.isEmpty(c.getSTime()) && !StringUtils.isEmpty(c.getETime()) && 
          c.getPointId().equals(re.getPointId()) && c
          .getIsNullCheck().intValue() == 1 && c
          .getCheckTime().getTime() >= DateUtil.stringToDate(checkDate + " 00:00:00", "yyyy-MM-dd HH:mm:ss").getTime() && c
          .getCheckTime().getTime() <= DateUtil.stringToDate(checkDate + " 23:59:59", "yyyy-MM-dd HH:mm:ss").getTime() && ("-"
          
          .equals(c.getSTime()) || 
          DateUtil.stringToDate(checkDate + " " + c.getSTime() + ":00", "yyyy-MM-dd HH:mm:ss").getTime() <= re.getCheckTime().getTime()) && ("-"

          
          .equals(c.getETime()) || 
          DateUtil.stringToDate(checkDate + " " + c.getETime() + ":59", "yyyy-MM-dd HH:mm:ss").getTime() > re.getCheckTime().getTime())) {
          curing = c;
          break;
        } 
      } 
    } 
    if (null == curing) {
      curing = new TblCheckSecurityCuring();
      curing.setOperId(relation.getOperId());
      curing.setOperName(relation.getOperName());
      curing.setOperCode(relation.getOperCode());
      curing.setLineId(relation.getLineId());
      curing.setLineName(relation.getLineName());
      curing.setSubLineId(relation.getSubLineId());
      curing.setSubLineName(relation.getSubLine());
      curing.setAreaId(relation.getAreaId());
      curing.setAreaName(relation.getAreaName());
      curing.setStationId(relation.getStationId());
      curing.setStationName(relation.getStationName());
      curing.setSecId(relation.getSecId());
      curing.setSecName(relation.getSecName());
      curing.setLineOrderNum(relation.getLineOrderNum());
      curing.setOperOrderNum(relation.getOperId());
      curing.setAreaOrderNum(relation.getAreaOrderNum());
      curing.setStationOrderNum(Integer.valueOf(Integer.parseInt(curing.getStationId())));
      curing.setTimeType(re.getTimeType());
      for (BasePointCheckConfig cf : configs) {
        if (!StringUtils.isEmpty(cf.getStime()) && !StringUtils.isEmpty(cf.getEtime()) && 
          cf.getPointId().equals(re.getPointId()) && ("-"
          
          .equals(cf.getStime()) || 
          DateUtil.stringToDate(checkDate + " " + cf.getStime() + ":00", "yyyy-MM-dd HH:mm:ss").getTime() <= re.getCheckTime().getTime()) && ("-"

          
          .equals(cf.getEtime()) || 
          DateUtil.stringToDate(checkDate + " " + cf.getEtime() + ":59", "yyyy-MM-dd HH:mm:ss").getTime() > re.getCheckTime().getTime())) {
          curing.setCheckNum(Integer.valueOf(1));
          curing.setPointConfigId(cf.getId());
          curing.setPeriodStart(cf.getStime());
          break;
        } 
      } 
    } 
    double realNum = 0.0D;
    double askNum = 0.0D;
    int proCount = 0, proType1 = 0, proType2 = 0, proType3 = 0, proType4 = 0, proType5 = 0, proType6 = 0, proType7 = 0, proType8 = 0, proType9 = 0;
    int checkProType1 = 0, checkProType2 = 0, checkProType3 = 0, checkProType4 = 0, checkProType5 = 0, checkProType6 = 0, checkProType7 = 0, checkProType8 = 0, checkProType9 = 0;
    if (CollUtil.isNotEmpty(re.getRecordList()))
      for (BaseCheckRecord record : re.getRecordList()) {
        if (record.getMid().intValue() == 1 && record.getSid().intValue() == 3)
          realNum = Double.parseDouble(record.getData()); 
        if (record.getMid().intValue() == 1 && record.getSid().intValue() == 1)
          askNum = Double.parseDouble(record.getData()); 
        if (record.getIsProblem().intValue() == 1) {
          proCount++;
          if (record.getMid().intValue() == 1)
            proType1++; 
          if (record.getMid().intValue() == 2)
            proType2++; 
          if (record.getMid().intValue() == 3)
            proType3++; 
          if (record.getMid().intValue() == 4)
            proType4++; 
          if (record.getMid().intValue() == 5)
            proType5++; 
          if (record.getMid().intValue() == 25)
            proType6++; 
          if (record.getMid().intValue() == 26)
            proType7++; 
          if (record.getMid().intValue() == 27)
            proType8++; 
          if (record.getMid().intValue() == 56)
            proType9++; 
        } 
        if (record.getMid().intValue() == 1)
          checkProType1++; 
        if (record.getMid().intValue() == 2)
          checkProType2++; 
        if (record.getMid().intValue() == 3)
          checkProType3++; 
        if (record.getMid().intValue() == 4)
          checkProType4++; 
        if (record.getMid().intValue() == 5)
          checkProType5++; 
        if (record.getMid().intValue() == 25)
          checkProType6++; 
        if (record.getMid().intValue() == 26)
          checkProType7++; 
        if (record.getMid().intValue() == 27)
          checkProType8++; 
        if (record.getMid().intValue() == 56)
          checkProType9++; 
      }  
    curing.setIsNullCheck(Integer.valueOf(0));
    curing.setCheckId(re.getId());
    curing.setPointId(re.getPointId());
    curing.setCheckTime(re.getCheckTime());
    curing.setRealNum(Double.valueOf(realNum));
    curing.setAskNum(Double.valueOf(askNum));
    curing.setCheckLevel(re.getLevel());
    curing.setIsPro(Integer.valueOf((proCount > 0) ? 1 : 0));
    curing.setRectifyType(re.getRectifyType());
    curing.setIsOver(Integer.valueOf(((re.getRectifyType().intValue() == 0 || re.getRectifyType().intValue() == 1) && re.getStatus().intValue() == 1) ? 1 : 0));
    curing.setCheckProType1(Integer.valueOf((checkProType1 > 0) ? 1 : 0));
    curing.setCheckProType2(Integer.valueOf((checkProType2 > 0) ? 1 : 0));
    curing.setCheckProType3(Integer.valueOf((checkProType3 > 0) ? 1 : 0));
    curing.setCheckProType4(Integer.valueOf((checkProType4 > 0) ? 1 : 0));
    curing.setCheckProType5(Integer.valueOf((checkProType5 > 0) ? 1 : 0));
    curing.setCheckProType6(Integer.valueOf((checkProType6 > 0) ? 1 : 0));
    curing.setCheckProType7(Integer.valueOf((checkProType7 > 0) ? 1 : 0));
    curing.setCheckProType8(Integer.valueOf((checkProType8 > 0) ? 1 : 0));
    curing.setCheckProType9(Integer.valueOf((checkProType9 > 0) ? 1 : 0));
    curing.setIsProType1(Integer.valueOf((proType1 > 0) ? 1 : 0));
    curing.setIsProType2(Integer.valueOf((proType2 > 0) ? 1 : 0));
    curing.setIsProType3(Integer.valueOf((proType3 > 0) ? 1 : 0));
    curing.setIsProType4(Integer.valueOf((proType4 > 0) ? 1 : 0));
    curing.setIsProType5(Integer.valueOf((proType5 > 0) ? 1 : 0));
    curing.setIsProType6(Integer.valueOf((proType6 > 0) ? 1 : 0));
    curing.setIsProType7(Integer.valueOf((proType7 > 0) ? 1 : 0));
    curing.setIsProType8(Integer.valueOf((proType8 > 0) ? 1 : 0));
    curing.setIsProType9(Integer.valueOf((proType9 > 0) ? 1 : 0));
    return curing;
  }
  
  public TblCheckSecurityCuring onlyInsertCuringTable(TblCheckSecurity re, SysStationRelation relation, List<BasePointCheckConfig> configs) {
    String checkDate = DateUtil.dateToString(re.getCheckTime(), "yyyy-MM-dd");
    TblCheckSecurityCuring curing = new TblCheckSecurityCuring();
    curing.setOperId(relation.getOperId());
    curing.setOperName(relation.getOperName());
    curing.setOperCode(relation.getOperCode());
    curing.setLineId(re.getLineId());
    curing.setLineName(re.getLineName());
    curing.setSubLineId(relation.getSubLineId());
    curing.setSubLineName(relation.getSubLine());
    curing.setAreaId(relation.getAreaId());
    curing.setAreaName(relation.getAreaName());
    curing.setStationId(relation.getStationId());
    curing.setStationName(relation.getStationName());
    curing.setSecId(relation.getSecId());
    curing.setSecName(relation.getSecName());
    curing.setLineOrderNum(relation.getLineOrderNum());
    curing.setOperOrderNum(relation.getOperId());
    curing.setAreaOrderNum(relation.getAreaOrderNum());
    curing.setStationOrderNum(Integer.valueOf(Integer.parseInt(curing.getStationId())));
    curing.setTimeType(re.getTimeType());
    for (BasePointCheckConfig cf : configs) {
      if (!StringUtils.isEmpty(cf.getStime()) && !StringUtils.isEmpty(cf.getEtime()) && 
        cf.getPointId().equals(re.getPointId()) && ("-"
        
        .equals(cf.getStime()) || 
        DateUtil.stringToDate(checkDate + " " + cf.getStime() + ":00", "yyyy-MM-dd HH:mm:ss").getTime() <= re.getCheckTime().getTime()) && ("-"

        
        .equals(cf.getEtime()) || 
        DateUtil.stringToDate(checkDate + " " + cf.getEtime() + ":59", "yyyy-MM-dd HH:mm:ss").getTime() > re.getCheckTime().getTime())) {
        curing.setCheckNum(Integer.valueOf(1));
        curing.setPointConfigId(cf.getId());
        curing.setPeriodStart(cf.getStime());
        break;
      } 
    } 
    double realNum = 0.0D;
    double askNum = 0.0D;
    int proCount = 0, proType1 = 0, proType2 = 0, proType3 = 0, proType4 = 0, proType5 = 0, proType6 = 0, proType7 = 0, proType8 = 0, proType9 = 0;
    int checkProType1 = 0, checkProType2 = 0, checkProType3 = 0, checkProType4 = 0, checkProType5 = 0, checkProType6 = 0, checkProType7 = 0, checkProType8 = 0, checkProType9 = 0;
    if (CollUtil.isNotEmpty(re.getRecordList()))
      for (BaseCheckRecord record : re.getRecordList()) {
        if (record.getMid().intValue() == 1 && record.getSid().intValue() == 3)
          realNum = Double.parseDouble(record.getData()); 
        if (record.getMid().intValue() == 1 && record.getSid().intValue() == 1)
          askNum = Double.parseDouble(record.getData()); 
        if (record.getIsProblem().intValue() == 1) {
          proCount++;
          if (record.getMid().intValue() == 1)
            proType1++; 
          if (record.getMid().intValue() == 2)
            proType2++; 
          if (record.getMid().intValue() == 3)
            proType3++; 
          if (record.getMid().intValue() == 4)
            proType4++; 
          if (record.getMid().intValue() == 5)
            proType5++; 
          if (record.getMid().intValue() == 25)
            proType6++; 
          if (record.getMid().intValue() == 26)
            proType7++; 
          if (record.getMid().intValue() == 27)
            proType8++; 
          if (record.getMid().intValue() == 56)
            proType9++; 
        } 
        if (record.getMid().intValue() == 1)
          checkProType1++; 
        if (record.getMid().intValue() == 2)
          checkProType2++; 
        if (record.getMid().intValue() == 3)
          checkProType3++; 
        if (record.getMid().intValue() == 4)
          checkProType4++; 
        if (record.getMid().intValue() == 5)
          checkProType5++; 
        if (record.getMid().intValue() == 25)
          checkProType6++; 
        if (record.getMid().intValue() == 26)
          checkProType7++; 
        if (record.getMid().intValue() == 27)
          checkProType8++; 
        if (record.getMid().intValue() == 56)
          checkProType9++; 
      }  
    curing.setIsNullCheck(Integer.valueOf(0));
    curing.setCheckId(re.getId());
    curing.setPointId(re.getPointId());
    curing.setCheckTime(re.getCheckTime());
    curing.setRealNum(Double.valueOf(realNum));
    curing.setAskNum(Double.valueOf(askNum));
    curing.setCheckLevel(re.getLevel());
    curing.setIsPro(Integer.valueOf((proCount > 0) ? 1 : 0));
    curing.setRectifyType(re.getRectifyType());
    curing.setIsOver(Integer.valueOf(((re.getRectifyType().intValue() == 0 || re.getRectifyType().intValue() == 1) && re.getStatus().intValue() == 1) ? 1 : 0));
    curing.setCheckProType1(Integer.valueOf((checkProType1 > 0) ? 1 : 0));
    curing.setCheckProType2(Integer.valueOf((checkProType2 > 0) ? 1 : 0));
    curing.setCheckProType3(Integer.valueOf((checkProType3 > 0) ? 1 : 0));
    curing.setCheckProType4(Integer.valueOf((checkProType4 > 0) ? 1 : 0));
    curing.setCheckProType5(Integer.valueOf((checkProType5 > 0) ? 1 : 0));
    curing.setCheckProType6(Integer.valueOf((checkProType6 > 0) ? 1 : 0));
    curing.setCheckProType7(Integer.valueOf((checkProType7 > 0) ? 1 : 0));
    curing.setCheckProType8(Integer.valueOf((checkProType8 > 0) ? 1 : 0));
    curing.setCheckProType9(Integer.valueOf((checkProType9 > 0) ? 1 : 0));
    curing.setIsProType1(Integer.valueOf((proType1 > 0) ? 1 : 0));
    curing.setIsProType2(Integer.valueOf((proType2 > 0) ? 1 : 0));
    curing.setIsProType3(Integer.valueOf((proType3 > 0) ? 1 : 0));
    curing.setIsProType4(Integer.valueOf((proType4 > 0) ? 1 : 0));
    curing.setIsProType5(Integer.valueOf((proType5 > 0) ? 1 : 0));
    curing.setIsProType6(Integer.valueOf((proType6 > 0) ? 1 : 0));
    curing.setIsProType7(Integer.valueOf((proType7 > 0) ? 1 : 0));
    curing.setIsProType8(Integer.valueOf((proType8 > 0) ? 1 : 0));
    curing.setIsProType9(Integer.valueOf((proType9 > 0) ? 1 : 0));
    return curing;
  }
  
  public void addCheckLog(TblCheckSecurityRectify rectify) {
    String currentUsername = SecurityUtils.getCurrentUsername();
    DeptVo dept = SecurityUtils.getCurrentUserDept();
    rectify.setCreateId(SecurityUtils.getCurrentUserId().toString());
    rectify.setCreateName(currentUsername);
    rectify.setCreateTime(new Date());
    rectify.setStatus(Integer.valueOf(1));
    rectify.setAssignDepart(dept.getName());
    rectify.setAssignName(currentUsername);
    rectify.setAssignTime(new Date());
    rectify.setAssignDepartLevel(dept.getLevel());
    rectify.setAssignDepartCode(dept.getCode());
    rectify.setAssignDepartId(dept.getId());
    rectify.setInitiator(currentUsername);
    rectify.setInitiatorDepartLevel(dept.getLevel());
    rectify.setInitiatorDepart(dept.getName());
    rectify.setInitiatorDepartCode(dept.getCode());
    rectify.setInitiatorDepartId(dept.getId());
    rectify.setInitiatorTime(new Date());
    rectify.setInitiatorDepartLevel(dept.getLevel());
    rectify.setInitiatorDepartLevel(dept.getLevel());
    rectify.setUpdateId(SecurityUtils.getCurrentUserId().toString());
    rectify.setUpdateName(SecurityUtils.getCurrentUsername());
    rectify.setUpdateTime(new Date());
    rectify.setStartTime(new Date());
    rectify.setEndTime(new Date());
    this.rectifyMapper.insert(rectify);
    this.logBiz.insertLog(rectify.getId(), "发起整改", dept.getName() + "现场整改", Integer.valueOf(0), dept);
  }
  
  public ObjectRestResponse addTblCheckSecurityRectify(TblCheckSecurityRectify rectify) {
    try {
      String currentUsername = SecurityUtils.getCurrentUsername();
      rectify.setCreateId(SecurityUtils.getCurrentUserId().toString());
      rectify.setCreateName(currentUsername);
      rectify.setCreateTime(new Date());
      Map<String, Object> varMap = new HashMap<>();
      String processId = null;
      DeptVo dept = SecurityUtils.getCurrentUserDept();
      Integer level = dept.getLevel();
      if (level == UserLevelEnum.集团用户.getValue()) {
        varMap.put("group", currentUsername);
        varMap.put("oper", RectifyEnum.运分用户.getName());
        varMap.put("area", RectifyEnum.站区用户.getName());
        varMap.put("team", RectifyEnum.班组用户.getName());
        varMap.put("areaChecker", RectifyEnum.站区审核.getName());
        varMap.put("operChecker", RectifyEnum.运营审核.getName());
        varMap.put("groupChecker", RectifyEnum.集团审核.getName());
        varMap.put("groupRevoker", RectifyEnum.集团驳回.getName());
        varMap.put("operRevoker", RectifyEnum.运营驳回.getName());
        varMap.put("areaRevoker", RectifyEnum.站区驳回.getName());
        varMap.put("groupOperRevoker", RectifyEnum.集团驳回运分提交.getName());
        varMap.put("operAreaRevoker", RectifyEnum.运分驳回站区提交.getName());
        varMap.put("groupAssign", Integer.valueOf(0));
        varMap.put("operAssign", Integer.valueOf(0));
        varMap.put("areaAssign", Integer.valueOf(0));
        varMap.put("teamSubmit", Integer.valueOf(0));
        varMap.put("areaSubmit", Integer.valueOf(0));
        varMap.put("operSubmit", Integer.valueOf(0));
        processId = this.oneBiz.startAct(varMap);
        rectify.setProcessRank(ProcessRankEnum.一级流程.getValue());
      } else if (level == UserLevelEnum.运营公司用户.getValue()) {
        varMap.put("oper", RectifyEnum.运分用户.getName());
        varMap.put("area", RectifyEnum.站区用户.getName());
        varMap.put("team", RectifyEnum.班组用户.getName());
        varMap.put("areaChecker", RectifyEnum.站区审核.getName());
        varMap.put("operChecker", RectifyEnum.运营审核.getName());
        varMap.put("operRevoker", RectifyEnum.运营驳回.getName());
        varMap.put("areaRevoker", RectifyEnum.站区驳回.getName());
        varMap.put("operAreaRevoker", RectifyEnum.运分驳回站区提交.getName());
        varMap.put("operAssign", Integer.valueOf(0));
        varMap.put("areaAssign", Integer.valueOf(0));
        varMap.put("teamSubmit", Integer.valueOf(0));
        varMap.put("areaSubmit", Integer.valueOf(0));
        processId = this.twoBiz.startAct(varMap);
        rectify.setProcessRank(ProcessRankEnum.二级流程.getValue());
      } else if (level == UserLevelEnum.站区用户.getValue()) {
        varMap.put("area", RectifyEnum.站区用户.getName());
        varMap.put("teamUser", RectifyEnum.班组用户.getName());
        varMap.put("areaChecker", RectifyEnum.站区审核.getName());
        varMap.put("areaRevoker", RectifyEnum.站区驳回.getName());
        processId = this.threeBiz.startAct(varMap);
        rectify.setProcessRank(ProcessRankEnum.三级流程.getValue());
      } else if (level == UserLevelEnum.班组用户.getValue()) {
        rectify.setStatus(Integer.valueOf(0));
        rectify.setAssignDepart(dept.getName());
        rectify.setAssignName(currentUsername);
        rectify.setAssignTime(new Date());
        rectify.setAssignDepartLevel(dept.getLevel());
        rectify.setAssignDepartCode(dept.getCode());
        rectify.setAssignDepartId(dept.getId());
        rectify.setInitiator(currentUsername);
        rectify.setInitiatorDepart(dept.getName());
        rectify.setInitiatorDepartCode(dept.getCode());
        rectify.setInitiatorDepartId(dept.getId());
        rectify.setInitiatorTime(new Date());
        rectify.setInitiatorDepartLevel(dept.getLevel());
        rectify.setInitiatorDepartLevel(dept.getLevel());
        rectify.setUpdateId(SecurityUtils.getCurrentUserId().toString());
        rectify.setUpdateName(SecurityUtils.getCurrentUsername());
        rectify.setUpdateTime(new Date());
        this.rectifyMapper.insert(rectify);
        this.logBiz.insertLog(rectify.getId(), "发起整改", rectify.getRecord(), Integer.valueOf(0), dept);
        return ObjectRestResponse.ok("发起成功");
      } 
      rectify.setType(Integer.valueOf(1));
      rectify.setStatus(Integer.valueOf(0));
      rectify.setInitiator(currentUsername);
      rectify.setInitiatorDepart(dept.getName());
      rectify.setInitiatorDepartCode(dept.getCode());
      rectify.setInitiatorDepartId(dept.getId());
      rectify.setInitiatorTime(new Date());
      rectify.setInitiatorDepartLevel(dept.getLevel());
      rectify.setActivityId(processId);
      this.rectifyMapper.insert(rectify);
      if (null != rectify.getPicList() && rectify.getPicList().size() > 0)
        this.attachmentsBiz.insertAttachments(rectify.getPicList(), rectify.getId(), Integer.valueOf(0), "tbl_check_security_rectify"); 
      this.logBiz.insertLog(rectify.getId(), "发起整改", rectify.getRecord(), Integer.valueOf(0), dept);
      TblCheckSecurity security = (TblCheckSecurity)this.securityMapper.selectById(rectify.getCheckId());
      List<Dept> dept2 = this.deptBiz.selectDeptCode(security.getStationId(), Integer.valueOf(dept.getLevel().intValue() + 1));
      if (null != dept2 && dept2.size() > 0)
        if (level == UserLevelEnum.集团用户.getValue()) {
          List<Dept> saftyList = (List<Dept>)dept2.stream().filter(a -> (a.getType().intValue() == 3)).collect(Collectors.toList());
          if (null != saftyList && saftyList.size() > 0) {
            assign(saftyList.get(0), rectify.getId());
          } else {
            List<Dept> operList = (List<Dept>)dept2.stream().filter(a -> (a.getType().intValue() == 2)).collect(Collectors.toList());
            if (null != operList && operList.size() > 0)
              assign(operList.get(0), rectify.getId()); 
          } 
        } else if (level == UserLevelEnum.运营公司用户.getValue()) {
          List<Dept> areaList = (List<Dept>)dept2.stream().filter(a -> (a.getType().intValue() == 4)).collect(Collectors.toList());
          if (null != areaList && areaList.size() > 0)
            assign(areaList.get(0), rectify.getId()); 
        }  
      this.dataLogBiz.insertLog(SecurityUtils.getCurrentUserDept().getId(), null, null, Integer.valueOf(MenuTypeEnum.整改管理.getValue()), Integer.valueOf(ModulePublicType.监督检查.getValue()), ModulePublicType.监督检查.name(), "", "新增安检整改", Integer.valueOf(0), Integer.valueOf(ModuleType.公共安全防范.getValue()), rectify.getId().toString());
      return ObjectRestResponse.ok("发起成功");
    } catch (Exception e) {
      e.printStackTrace();
      return ObjectRestResponse.error("发起失败");
    } 
  }
  
  public ObjectRestResponse assign(Dept dept1, Integer id) {
    try {
      TblCheckSecurityRectify tblCheckSecurityRectify = (TblCheckSecurityRectify)this.rectifyMapper.selectById(id);
      String activityId = tblCheckSecurityRectify.getActivityId();
      Integer processRank = tblCheckSecurityRectify.getProcessRank();
      if (StringUtils.isEmpty(activityId) && processRank == null)
        return ObjectRestResponse.error("班组发起无法指派"); 
      DeptVo dept = SecurityUtils.getCurrentUserDept();
      Integer level = dept.getLevel();
      Map<String, Object> varMap = new HashMap<>();
      String currentUsername = SecurityUtils.getCurrentUsername();
      boolean submit = false;
      boolean isOne = false;
      boolean isTwo = false;
      boolean isThree = false;
      Task task = null;
      if (level == UserLevelEnum.集团用户.getValue()) {
        if (processRank == ProcessRankEnum.一级流程.getValue()) {
          task = this.oneBiz.queryTaskByProcess(activityId);
          varMap.put("oper", RectifyEnum.运分用户.getName());
          varMap.put("groupAssign", Integer.valueOf(1));
          isOne = true;
        } 
      } else if (level == UserLevelEnum.运营公司用户.getValue()) {
        if (processRank == ProcessRankEnum.一级流程.getValue()) {
          task = this.oneBiz.queryTaskByProcess(activityId);
          varMap.put("area", RectifyEnum.站区用户.getName());
          varMap.put("operAssign", Integer.valueOf(1));
          varMap.put("operSubmit", Integer.valueOf(0));
          isOne = true;
        } else if (processRank == ProcessRankEnum.二级流程.getValue()) {
          task = this.twoBiz.queryTaskByProcess(activityId);
          varMap.put("area", RectifyEnum.站区用户.getName());
          varMap.put("operAssign", Integer.valueOf(1));
          isTwo = true;
        } 
      } else if (level == UserLevelEnum.站区用户.getValue()) {
        if (processRank == ProcessRankEnum.一级流程.getValue()) {
          task = this.oneBiz.queryTaskByProcess(activityId);
          varMap.put("team", RectifyEnum.班组用户.getName());
          varMap.put("areaAssign", Integer.valueOf(1));
          varMap.put("areaSubmit", Integer.valueOf(0));
          isOne = true;
        } else if (processRank == ProcessRankEnum.二级流程.getValue()) {
          task = this.twoBiz.queryTaskByProcess(activityId);
          varMap.put("team", RectifyEnum.班组用户.getName());
          varMap.put("areaAssign", Integer.valueOf(1));
          varMap.put("areaSubmit", Integer.valueOf(0));
          isTwo = true;
        } else if (processRank == ProcessRankEnum.三级流程.getValue()) {
          task = this.threeBiz.queryTaskByProcess(activityId);
          varMap.put("teamUser", RectifyEnum.班组用户.getName());
          isThree = true;
        } 
      } else if (level == UserLevelEnum.班组用户.getValue()) {
      
      } 
      tblCheckSecurityRectify.setUpdateId(SecurityUtils.getCurrentUserId().toString());
      tblCheckSecurityRectify.setUpdateName(SecurityUtils.getCurrentUsername());
      tblCheckSecurityRectify.setUpdateTime(new Date());
      if (isOne)
        submit = this.oneBiz.submit(task.getId(), task.getAssignee(), varMap); 
      if (isTwo)
        submit = this.twoBiz.submit(task.getId(), task.getAssignee(), varMap); 
      if (isThree)
        submit = this.threeBiz.submit(task.getId(), task.getAssignee(), varMap); 
      if (submit) {
        DeptVo vo = SecurityUtils.getCurrentUserDept();
        if (vo.getLevel().intValue() == 1) {
          if (vo.getType().intValue() == 3) {
            Dept oper = this.deptMapper.selectDeptByPidAndType(Integer.valueOf(dept1.getId().intValue()), Integer.valueOf(3));
            if (null != oper) {
              this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(oper.getId().intValue()), oper.getName(), oper.getCode()));
              tblCheckSecurityRectify.setAssignDepart(oper.getName());
              tblCheckSecurityRectify.setAssignTime(new Date());
              tblCheckSecurityRectify.setAssignDepartCode(oper.getCode());
              tblCheckSecurityRectify.setAssignDepartId(Integer.valueOf(oper.getId().intValue()));
              tblCheckSecurityRectify.setAssignDepartLevel(oper.getLevel());
            } else {
              this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(dept1.getId().intValue()), dept1.getName(), dept1.getCode()));
              tblCheckSecurityRectify.setAssignDepart(dept1.getName());
              tblCheckSecurityRectify.setAssignTime(new Date());
              tblCheckSecurityRectify.setAssignDepartCode(dept1.getCode());
              tblCheckSecurityRectify.setAssignDepartId(Integer.valueOf(dept1.getId().intValue()));
              tblCheckSecurityRectify.setAssignDepartLevel(dept1.getLevel());
            } 
          } else {
            Dept depts = this.deptMapper.selectDeptByPidAndType(vo.getId(), Integer.valueOf(3));
            if (null != depts)
              this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(depts.getId().intValue()), depts.getName(), depts.getCode())); 
            Dept oper = this.deptMapper.selectDeptByPidAndType(Integer.valueOf(dept1.getId().intValue()), Integer.valueOf(3));
            if (null != oper) {
              this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(oper.getId().intValue()), oper.getName(), oper.getCode()));
              tblCheckSecurityRectify.setAssignDepart(oper.getName());
              tblCheckSecurityRectify.setAssignTime(new Date());
              tblCheckSecurityRectify.setAssignDepartCode(oper.getCode());
              tblCheckSecurityRectify.setAssignDepartId(Integer.valueOf(oper.getId().intValue()));
              tblCheckSecurityRectify.setAssignDepartLevel(oper.getLevel());
            } else {
              this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(dept1.getId().intValue()), dept1.getName(), dept1.getCode()));
              tblCheckSecurityRectify.setAssignDepart(dept1.getName());
              tblCheckSecurityRectify.setAssignTime(new Date());
              tblCheckSecurityRectify.setAssignDepartCode(dept1.getCode());
              tblCheckSecurityRectify.setAssignDepartId(Integer.valueOf(dept1.getId().intValue()));
              tblCheckSecurityRectify.setAssignDepartLevel(dept1.getLevel());
            } 
          } 
        } else if (vo.getLevel().intValue() == 2) {
          this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(dept1.getId().intValue()), dept1.getName(), dept1.getCode()));
          tblCheckSecurityRectify.setAssignDepart(dept1.getName());
          tblCheckSecurityRectify.setAssignTime(new Date());
          tblCheckSecurityRectify.setAssignDepartCode(dept1.getCode());
          tblCheckSecurityRectify.setAssignDepartId(Integer.valueOf(dept1.getId().intValue()));
          tblCheckSecurityRectify.setAssignDepartLevel(dept1.getLevel());
        } else {
          this.logBiz.insertLog(id, "自动指派", "自动指派", Integer.valueOf(1), new DeptVo(Integer.valueOf(dept1.getId().intValue()), dept1.getName(), dept1.getCode()));
        } 
        this.rectifyMapper.updateById(tblCheckSecurityRectify);
        return ObjectRestResponse.ok("指派成功");
      } 
      return ObjectRestResponse.error("指派失败");
    } catch (Exception e) {
      e.printStackTrace();
      return ObjectRestResponse.error("指派异常");
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ObjectRestResponse update(TblCheckSecurity re) {
    try {
      DeptVo dept = SecurityUtils.getCurrentUserDept();
      Dept de = this.deptBiz.selectDeptByCode(dept.getId());
      if (null != de) {
        re.setOperCode(de.getCode());
        re.setOperId(de.getId().toString());
        re.setOperName(de.getName());
      } 
      if (StringUtils.isNotEmpty(re.getPointId())) {
        Integer timeType = this.rectifyMapper.selectTimeType(re.getPointId(), DateUtil.dateToString(re.getCheckTime(), "yyyy-MM-dd HH:mm:ss"));
        re.setTimeType(timeType);
      } 
      re.setStatus(Integer.valueOf(0));
      re.setCheckDeaprtCode(dept.getCode());
      re.setCheckDepartId(dept.getId().toString());
      re.setCheckDepart(dept.getName());
      re.setLevel(dept.getLevel());
      re.setUpdateId(SecurityUtils.getCurrentUserId().toString());
      re.setUpdateName(SecurityUtils.getCurrentUsername());
      re.setUpdateTime(new Date());
      if (re.getRectifyType().intValue() == 1) {
        Date date = null;
        if (re.getRectifyPeriod().intValue() == 1) {
          date = DateUtils.addDays(new Date(), 3);
        } else if (re.getRectifyPeriod().intValue() == 2) {
          date = DateUtils.addDays(new Date(), 7);
        } else if (re.getRectifyPeriod().intValue() == 3) {
          date = DateUtils.addDays(new Date(), 30);
        } 
        re.setRectifyTime(date);
      } 
      this.securityMapper.updateById(re);
      if (null != re.getPicList() && re.getPicList().size() > 0) {
        this.attachmentsBiz.deleteByFid(re.getId(), Integer.valueOf(0), "tbl_check_security");
        this.attachmentsBiz.insertAttachments(re.getPicList(), re.getId(), Integer.valueOf(0), "tbl_check_security");
      } 
      if (null != re.getRecordList() && re.getRecordList().size() > 0) {
        this.recordMapper.deleteCheckRecord(re.getId(), Integer.valueOf(1));
        for (BaseCheckRecord record : re.getRecordList()) {
          record.setCid(re.getId());
          record.setType(Integer.valueOf(1));
          record.setCreateTime(new Date());
          this.recordMapper.insert(record);
        } 
      } 
      return ObjectRestResponse.ok("修改成功");
    } catch (Exception e) {
      e.printStackTrace();
      return ObjectRestResponse.error("修改失败");
    } 
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ObjectRestResponse delete(Integer[] ids) {
    try {
      for (Integer id : ids) {
        TblCheckSecurity re = (TblCheckSecurity)this.securityMapper.selectById(id);
        if (null != re)
          this.recordMapper.deleteCheckRecord(re.getId(), Integer.valueOf(1)); 
        this.attachmentsBiz.deleteByFid(id, Integer.valueOf(0), "tbl_check_security");
        this.securityMapper.deleteById(id);
      } 
      return ObjectRestResponse.ok("删除成功");
    } catch (Exception e) {
      e.printStackTrace();
      return ObjectRestResponse.error("删除失败");
    } 
  }
  
  public TblCheckSecurity detail(Integer id) {
    try {
      TblCheckSecurity re = (TblCheckSecurity)this.securityMapper.selectById(id);
      if (null != re) {
        Integer status = this.rectifyMapper.selectSecurityRecord(id);
        if (null != status)
          if (status.intValue() == 0) {
            re.setStatusStr("整改中");
          } else if (status.intValue() == 1) {
            re.setStatusStr("整改完成");
          } else if (status.intValue() == 2) {
            re.setStatusStr("已取消");
          }  
        List<TblCheckSecurityAjy> ajyList = this.securityAjyMapper.selectByCheckId(re.getId());
        re.setCheckAjyList(ajyList);
        List<Map<String, Object>> pro = this.recordMapper.selectDetailDesc(id, null);
        if (null != pro && pro.size() > 0) {
          if (CollUtil.isNotEmpty(ajyList)) {
            String proDesc = (new StringBuilder()).append(((Map)pro.get(0)).get("proDesc")).append("").toString();
            ((Map<String, String>)pro.get(0)).put("proDesc", proDesc + ",在岗人员：" + (String)ajyList.stream().map(x -> x.getName()).collect(Collectors.joining(",")));
          } 
          for (Map<String, Object> item : pro) {
            String mid = item.get("mid").toString();
            List<TblAttachments> list = this.attachmentsBiz.selectAttachments(id, "base_check_record", Integer.valueOf(mid));
            item.put("checkItemFileList", list);
          } 
        } 
        re.setProblemDesc(pro);
        List<BaseCheckRecord> baseCheckRecords = this.recordMapper.selectCheckRecordList(id, Integer.valueOf(1));
        re.setRecordList(baseCheckRecords);
        re.setPicList(this.attachmentsBiz.selectAttachments(id, "tbl_check_security", Integer.valueOf(0)));
        TblCheckSecurityRectify rectify = this.rectifyMapper.selectByCheckId(id);
        if (null != rectify && 1 == re.getRectifyType().intValue())
          re.setRectifyLogList(this.logBiz.selectRectifyLog(rectify.getId())); 
      } 
      return re;
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } 
  }
  
  public TblCheckSecurity detail(Integer id, Integer isPro) {
    try {
      TblCheckSecurity re = (TblCheckSecurity)this.securityMapper.selectById(id);
      if (null != re) {
        List<Map<String, Object>> pro = this.recordMapper.selectDetailDesc(id, Integer.valueOf(1));
        if (null != pro && pro.size() > 0)
          for (Map<String, Object> item : pro) {
            String mid = item.get("mid").toString();
            List<TblAttachments> list = this.attachmentsBiz.selectAttachments(id, "base_check_record", Integer.valueOf(mid));
            item.put("checkItemFileList", list);
          }  
        re.setProblemDesc(pro);
        List<BaseCheckRecord> baseCheckRecords = this.recordMapper.selectCheckRecordList(id, Integer.valueOf(1));
        re.setRecordList(baseCheckRecords);
        re.setPicList(this.attachmentsBiz.selectAttachments(id, "tbl_check_security", Integer.valueOf(0)));
      } 
      return re;
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } 
  }
  
  public ObjectRestResponse cancelHistory() {
    LambdaQueryWrapper<TblCheckSecurity> query = new LambdaQueryWrapper();
    query.eq(TblCheckSecurity::getStatus, Integer.valueOf(2));
    List<TblCheckSecurity> list = this.securityMapper.selectList((Wrapper)query);
    for (TblCheckSecurity tblCheckSecurity : list) {
      tblCheckSecurity.setStatus(Integer.valueOf(2));
      tblCheckSecurity.setUpdateId(SecurityUtils.getCurrentUserId().toString());
      tblCheckSecurity.setUpdateName(SecurityUtils.getCurrentUserNickName());
      tblCheckSecurity.setUpdateTime(new Date());
      this.securityMapper.updateById(tblCheckSecurity);
      TblCheckSecurityRectify tblCheckSecurityRectify = this.rectifyMapper.selectByCheckId(tblCheckSecurity.getId());
      if (tblCheckSecurityRectify == null)
        continue; 
      tblCheckSecurityRectify.setStatus(Integer.valueOf(2));
      this.rectifyMapper.updateById(tblCheckSecurityRectify);
      String activityId = tblCheckSecurityRectify.getActivityId();
      Integer processRank = tblCheckSecurityRectify.getProcessRank();
      if (StringUtils.isNotEmpty(activityId)) {
        DeptVo dept = SecurityUtils.getCurrentUserDept();
        if (dept.getCode().equals(tblCheckSecurityRectify.getInitiatorDepartCode())) {
          if (processRank == ProcessRankEnum.一级流程.getValue()) {
            this.oneBiz.cancel(activityId, "取消申请");
          } else if (processRank == ProcessRankEnum.二级流程.getValue()) {
            this.twoBiz.cancel(activityId, "取消申请");
          } else if (processRank == ProcessRankEnum.三级流程.getValue()) {
            this.threeBiz.cancel(activityId, "取消申请");
          } 
          tblCheckSecurityRectify.setStatus(Integer.valueOf(2));
          tblCheckSecurityRectify.setUpdateId(SecurityUtils.getCurrentUserId().toString());
          tblCheckSecurityRectify.setUpdateName(SecurityUtils.getCurrentUsername());
          tblCheckSecurityRectify.setUpdateTime(new Date());
          this.rectifyMapper.updateById(tblCheckSecurityRectify);
        } 
      } 
    } 
    return ObjectRestResponse.ok();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ObjectRestResponse cancel(Integer id) {
    try {
      TblCheckSecurity tblCheckSecurity = (TblCheckSecurity)this.securityMapper.selectById(id);
      tblCheckSecurity.setStatus(Integer.valueOf(2));
      tblCheckSecurity.setUpdateId(SecurityUtils.getCurrentUserId().toString());
      tblCheckSecurity.setUpdateName(SecurityUtils.getCurrentUserNickName());
      tblCheckSecurity.setUpdateTime(new Date());
      this.securityMapper.updateById(tblCheckSecurity);
      deleteCuring(tblCheckSecurity);
      TblCheckSecurityRectify tblCheckSecurityRectify = this.rectifyMapper.selectByCheckId(id);
      if (tblCheckSecurityRectify == null)
        return ObjectRestResponse.ok(); 
      tblCheckSecurityRectify.setStatus(Integer.valueOf(2));
      this.rectifyMapper.updateById(tblCheckSecurityRectify);
      String activityId = tblCheckSecurityRectify.getActivityId();
      Integer processRank = tblCheckSecurityRectify.getProcessRank();
      if (StringUtils.isNotEmpty(activityId)) {
        DeptVo dept = SecurityUtils.getCurrentUserDept();
        if (dept.getCode().equals(tblCheckSecurityRectify.getInitiatorDepartCode())) {
          boolean a = false;
          if (processRank == ProcessRankEnum.一级流程.getValue()) {
            a = this.oneBiz.cancel(activityId, "取消申请");
          } else if (processRank == ProcessRankEnum.二级流程.getValue()) {
            a = this.twoBiz.cancel(activityId, "取消申请");
          } else if (processRank == ProcessRankEnum.三级流程.getValue()) {
            a = this.threeBiz.cancel(activityId, "取消申请");
          } 
          this.logBiz.insertLog(id, "取消申请", dept.getName() + "取消申请", Integer.valueOf(0), dept);
          tblCheckSecurityRectify.setStatus(Integer.valueOf(2));
          tblCheckSecurityRectify.setUpdateId(SecurityUtils.getCurrentUserId().toString());
          tblCheckSecurityRectify.setUpdateName(SecurityUtils.getCurrentUsername());
          tblCheckSecurityRectify.setUpdateTime(new Date());
          this.rectifyMapper.updateById(tblCheckSecurityRectify);
          if (a)
            return ObjectRestResponse.ok("作废成功"); 
          return ObjectRestResponse.error("作废失败");
        } 
      } 
      if (1 == this.dictDetailService.getDictByNameAndStr("data_approve", "check_security").intValue())
        this.dataApproveBiz.complate(new DataApprove(Long.valueOf(Long.parseLong(id.toString())), 
              SecurityUtils.getCurrentUserId(), 
              SecurityUtils.getCurrentUserNickName(), null)); 
      return ObjectRestResponse.error("作废成功");
    } catch (Exception e) {
      TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
      e.printStackTrace();
      return ObjectRestResponse.error("作废失败");
    } 
  }
  
  private void deleteCuring(TblCheckSecurity se) {
    BasePointCheckConfig config = this.pointCheckConfigMapper.queryConfigByPoint(se.getPointId(), DateUtil.dateToString(se.getCheckTime(), "yyyy-MM-dd HH:mm:ss"));
    Integer shouldNum = config.getCheckNum();
    List<TblCheckSecurityCuring> checkData = this.securityCuringMapper.getCheckData(se.getPointId(), DateUtil.dateToString(se.getCheckTime(), "yyyy-MM-dd HH:mm:ss"));
    int checkNum = checkData.size();
    if (checkNum > shouldNum.intValue()) {
      this.securityCuringMapper.delete((Wrapper)(new LambdaQueryWrapper())
          .eq(TblCheckSecurityCuring::getCheckId, se.getId()));
    } else {
      LambdaQueryWrapper<TblCheckSecurityCuring> wrapper = new LambdaQueryWrapper();
      wrapper.eq(TblCheckSecurityCuring::getCheckId, se.getId());
      TblCheckSecurityCuring curing = (TblCheckSecurityCuring)this.securityCuringMapper.selectOne((Wrapper)wrapper);
      curing.setCheckTime(DateUtil.stringToDate(DateUtil.dateToString(curing.getCheckTime(), "yyyy-MM-dd") + " 00:00:00", "yyyy-MM-dd HH:mm:ss"));
      this.securityCuringMapper.updateDefaultBean(curing);
    } 
  }
}
